<?php

namespace VfxApply\Plugin\Natron;

use VfxApply\Plugin;
use VfxApply\Input;
use VfxApply\Output;
use VfxApply\Preset;

class NatronPlugin extends Plugin
{
    public function getName()
    {
        return "natron";
    }
    
    public function applyPreset(Preset $preset, Input $input, Output $output)
    {
        $project = $preset->get("project");
        $file = $preset->getResourcePath($project);

        $in_node = $preset->get("reader");
        $out_node = $preset->get("writer");
        $in_file = $input->getFilename();
        $out_file = $output->getFilename();

        $cmdl = sprintf(
            "NatronRenderer %s -i %s %s -o %s %s", 
            escapeshellarg($file),
            $in_node, escapeshellarg($in_file),
            $out_node, escapeshellarg($out_file)
        );

        echo $cmdl."\n";
    }

}

return new NatronPlugin();